% My_COM

% Author: Yongsoo Yang, UCLA Physics & Astronomy
%         yongsoo.ysyang@gmail.com

% This code calculated a center-of-mass position of a 2D image

% input paramters
% img: a real-valued 2D image array

% output paramters
% comX: x-direction (along 1st dimension of MATLAB array) CM position
% comY: y-direction (along 2nd dimension of MATLAB array) CM position

function [comX, comY] = My_COM(img)
    xdim = size(img,1);
    ydim = size(img,2);
    [Y, X] = meshgrid(1:1:ydim,1:1:xdim);
    comX = sum(sum(X.*img,2),1) / sum(img(:));
    comY = sum(sum(Y.*img,2),1) / sum(img(:));
end
    